
	package aspects;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.sql.Statement;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.ArrayList;
	import java.util.Collection;
	import java.util.Iterator;
	import net.sf.hibernate.HibernateException;
	import net.sf.hibernate.dialect.Dialect;
	import net.sf.hibernate.sql.Select;
    
	import persistence.DatabaseConnection;
    import persistence.type.*;
    import persistence.Utilities;
    import com.sun.jdori.common.query.MyMemoryQuery;
    
    import persistence.exceptions.DeleteException;
	import persistence.exceptions.UpdateException;
	import persistence.exceptions.WriteException;
	
	import persistence.transaction.Transaction;
  
  
  public privileged aspect PersistenceIntroducer{


  
	
		declare parents: casestudy.Address implements Persistent;
	
	
		declare parents: testApp.PrimitiveClass implements Persistent;			
		declare parents: testApp.PrimitiveClass.TestClass implements Persistent;			
		declare parents: testApp.PrimitiveClass.TestClass.InnerTestClass implements Persistent;			
		declare parents: testApp.PrimitiveClass.NestedClass implements Persistent;
	
	
		declare parents: javapro.Project implements Persistent;
	
	
		declare parents: testApp.TestInterface implements Persistent;
	
	
		declare parents: javapro.Employee implements Persistent;
	
	
		declare parents: casestudy.Name implements Persistent;
	
	
		declare parents: testApp.PersistentClass implements Persistent;			
		declare parents: testApp.PersistentClass.PersistentInnerClass implements Persistent;
	
	
		declare parents: testApp.ChildPersistentClass implements Persistent;
	
	
		declare parents: javapro.Address implements Persistent;
	
	
		declare parents: casestudy.Student implements Persistent;
	
	
		declare parents: casestudy.Major implements Persistent;
	
	
		declare parents: casestudy.Curriculum implements Persistent;
	
	
		declare parents: casestudy.Course implements Persistent;
	
	
		declare parents: testApp.testPackage.PersistentClass implements Persistent;
	
	
		declare parents: javapro.Department implements Persistent;
	

	private static ObjectIDFactory fab=new ObjectIDFactory();  
  	private ObjectID Persistent.OID=fab.getObjectID(this);
  	
  	public ObjectID Persistent.getOID(){
  		return OID;
  	}
  	
	public void Persistent.setOID(ObjectID ob){
		OID=ob;
	}  	
  	
	public void Persistent.write() throws WriteException{}
  	
	public void Persistent.update() throws UpdateException{}
  	
  	public void Persistent.delete() throws DeleteException{}  
  	
  	public void Persistent.write(Transaction trans) throws WriteException{write();}
  	
	public void Persistent.update(Transaction trans) throws UpdateException{update();}
  	
	public void Persistent.delete(Transaction trans) throws DeleteException{delete();}
	
	private String ObjectID.cClass="";
  	
	/**
    * Get indication of current class of object with this ObjectID, depending on position in inheritance tree.
	* @return Indication of class of object with this ObjectID	 
	*/
	public String ObjectID.getCClass(){
		return cClass;
	}
	
    /**
	* Adjust current class of object.
	*/
	public void ObjectID.setCClass(String ccClass){
		cClass=ccClass;
	}
	
	pointcut IDConstructor(ObjectID OID,String claName):this(OID)&&((execution(ObjectID+.new(String))&&args(claName))||(execution(ObjectID+.new(..,String))&&args(..,claName)));
	
	declare error:call(public * ObjectID+.*etCClass(..))&&!within(aspects..*):"g/setCClass(..) mag je niet gebruiken buiten aspects-package!";
	
	after(ObjectID OID,String claName):IDConstructor(OID,claName){
		OID.cClass=claName;
	}
	
	public int Persistent.hashCode(){
		return OID.hashCode();  	
	}
  	
/*	boolean around(persistence.type.Persistent pers,Object ob):execution(public boolean persistence.type.Persistent+.equals(Object))&&this(pers)&&args(ob){
		return proceed(pers,ob)&&((Persistent)ob).OID.equals(pers.OID);
	}*/
	
	/*int around(ObjectID OID,Object ob):this(OID)&&execution(public int ObjectID+.compareTo(Object))&&args(ob)&&within(aspects.*){
		String temp=((ObjectID)ob).toString()+ "___" + ((ObjectID)ob).getCClass().replaceAll("\\.","_");
		return (OID.toString()+OID.getCClass().replaceAll("\\.","_")).compareTo(temp);
	}NUTTIG???*/
	
		public pointcut writedeleteupdate():execution(public void persistence.type.Persistent.write() throws persistence.exceptions.WriteException)
	||execution(public void persistence.type.Persistent.delete() throws persistence.exceptions.DeleteException)
	||execution(public void persistence.type.Persistent.update() throws persistence.exceptions.UpdateException);
	
	public pointcut read():execution(public static Object persistence.type.Persistent.QueryManager.read(ObjectID,..));
	
	public pointcut walk():call(
	public Object com.sun.jdori.query.TreeWalker.walk(
		com.sun.jdori.query.Node,
		com.sun.jdori.query.NodeVisitor+));
	
	public pointcut implementorAdvice():adviceexecution()&&within(aspects.imp..*);
	
	public pointcut persistentExecution():(writedeleteupdate()||read()||walk())&&!cflow(implementorAdvice());//adviceexecution());
	
	public pointcut twritedeleteupdate(persistence.transaction.Transaction trans):(execution(public void persistence.type.Persistent.write(persistence.transaction.Transaction) throws persistence.exceptions.WriteException)
||execution(public void persistence.type.Persistent.delete(persistence.transaction.Transaction) throws persistence.exceptions.DeleteException)
||execution(public void persistence.type.Persistent.update(persistence.transaction.Transaction) throws persistence.exceptions.UpdateException))&&args(trans);
	
	public pointcut tread(persistence.transaction.Transaction trans):execution(public static Object persistence.type.Persistent.QueryManager.read(persistence.transaction.Transaction,..))&&args(trans,..);
	
	public pointcut tpersistentExecution(persistence.transaction.Transaction trans):(twritedeleteupdate(trans)||tread(trans))&&!cflow(PersistenceIntroducer.implementorAdvice());//adviceexecution());

  }  	
  