
	package aspects.imp.casestudy;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Statement;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.Iterator;
	
	import java.lang.reflect.Constructor;
	import java.lang.reflect.InvocationTargetException;
	import java.lang.reflect.Modifier;
	
    import persistence.type.*;
    import com.sun.jdori.common.query.MyMemoryQuery;
    import com.sun.jdori.query.JDOQueryException;
  
  public privileged aspect Course_aspect{
  
pointcut writer_casestudy_Course(casestudy.Course obj): this(obj) && execution(public void persistence.type.Persistent.write() throws persistence.exceptions.WriteException);
after(casestudy.Course obj)  throws persistence.exceptions.WriteException: writer_casestudy_Course(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
java.util.Collection obj0=obj.getPrerequisites();
if(obj0!=null){
Iterator it0=obj0.iterator();
int i0=0;
while(it0.hasNext()){
casestudy.Course al1=((casestudy.Course)it0.next());
stmt=connection.createStatement();
stmt.executeUpdate("insert into alias1616369544 ($refOID$, $POSITION$, $prerequisites$) values ('"+obj.getOID().toString()+"', "+i0+", '"+((al1!=null)?al1.getOID().toString():"null")+"')");
stmt.close();
i0++;
}
}
stmt=connection.createStatement();
stmt.executeUpdate("insert into alias799232454 ($OID$, $courseID$, $courseName$, $courseWeight$) values ('"+obj.getOID().toString()+"', '"+obj.getCourseID()+"', '"+obj.getCourseName()+"', "+obj.getCourseWeight()+")");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.WriteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut updater_casestudy_Course(casestudy.Course obj): this(obj) && execution(public void persistence.type.Persistent.update() throws persistence.exceptions.UpdateException);
after(casestudy.Course obj) throws persistence.exceptions.UpdateException: updater_casestudy_Course(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=connection.createStatement();
stmt.executeUpdate("delete from alias1616369544 where $refOID$='"+obj.getOID().toString()+"'");
Iterator it=null;
java.util.Collection obj20000=obj.getPrerequisites();
if(obj20000!=null){
Iterator it20000=obj20000.iterator();
int i20000=0;
while(it20000.hasNext()){
casestudy.Course al20001=((casestudy.Course)it20000.next());
stmt=connection.createStatement();
stmt.executeUpdate("insert into alias1616369544 ($refOID$, $POSITION$, $prerequisites$) values ('"+obj.getOID().toString()+"', "+i20000+", '"+((al20001!=null)?al20001.getOID().toString():"null")+"')");
stmt.close();
i20000++;
}
}
stmt=connection.createStatement();
stmt.executeUpdate("update alias799232454 set $courseID$='"+obj.getCourseID()+"', $courseName$='"+obj.getCourseName()+"', $courseWeight$="+obj.getCourseWeight()+" where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.UpdateException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut deleter_casestudy_Course(casestudy.Course obj): this(obj) && execution(public void persistence.type.Persistent.delete() throws persistence.exceptions.DeleteException);
after(casestudy.Course obj) throws persistence.exceptions.DeleteException: deleter_casestudy_Course(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=connection.createStatement();
stmt.executeUpdate("delete from alias1616369544 where $refOID$='"+obj.getOID().toString()+"'");
stmt.executeUpdate("delete from alias799232454 where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.DeleteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut reader_casestudy_Course(ObjectID OID,boolean deep): args(OID,deep) && execution(public Object persistence.type.Persistent.QueryManager.read(ObjectID,boolean)) && if(OID.getCClass().equals("casestudy.Course"));
Object around(ObjectID OID,boolean deep): reader_casestudy_Course(OID,deep){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
ResultSet res=null;
stmt=connection.createStatement();
res=stmt.executeQuery("select * from alias799232454 where $OID$='"+OID.toString()+"'");
Object obj=null;
if(res.next()){
obj=persistence.Utilities.constructObject(OID);
persistence.type.ObjectIDFactory facobj0=new persistence.type.ObjectIDFactory();
persistence.type.ObjectID obj0=facobj0.translateToObjectID(OID.toString());
((casestudy.Course)obj).setOID(obj0);
java.lang.String obj1=new String(res.getString("$courseID$"));
((casestudy.Course)obj).setCourseID(obj1);
java.lang.String obj2=new String(res.getString("$courseName$"));
((casestudy.Course)obj).setCourseName(obj2);
int obj3=res.getInt("$courseWeight$");
((casestudy.Course)obj).setCourseWeight(obj3);
Statement stmt5=connection.createStatement();
ResultSet res5=stmt5.executeQuery("select * from alias1616369544 where $refOID$='"+OID.toString()+"'");
java.util.Collection obj4=null;
if(res5.next()){
obj4= new java.util.ArrayList();
do{
persistence.type.ObjectIDFactory facobj5=new persistence.type.ObjectIDFactory();
casestudy.Course obj5=null;
if(!res5.getString("$prerequisites$").equalsIgnoreCase("null")){
if(!deep){
obj5=(casestudy.Course)persistence.Utilities.constructObject(facobj5.translateToObjectID(res5.getString("$prerequisites$")));
obj5.setOID(facobj5.translateToObjectID(res5.getString("$prerequisites$")));
}else{
obj5=(casestudy.Course)persistence.type.Persistent.QueryManager.read(facobj5.translateToObjectID(res5.getString("$prerequisites$")),deep);
}}
obj4.add(obj5);
}while(res5.next());
}
res5.close();
stmt5.close();
((casestudy.Course)obj).setPrerequisites(obj4);
}
res.close();
stmt.close();
return obj;
}catch(Exception e){
//doe voorlopig niets en gebruik transactie-aspect
}finally{
conFac.closeConnection(connection);
}
return null;
}
pointcut getJoins_casestudy_Course(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : this(
mem)
&& call(
	private void com.sun.jdori.common.query.MyMemoryQuery.getJoins(
String,
String,
String,
boolean))
&& args(attr, thisType, foreignAttr, outer)
&& if (thisType.equals("casestudy.Course"));

	/**
* Enkel Collections, arrays, Maps en persistent <--> anders negeren
*/
after(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : getJoins_casestudy_Course(
mem,
attr,
thisType,
foreignAttr,
outer) {
//nesting: ontrafel echte naam attribuut door aliassen achterwaarts op te zoeken
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
String thisAlias=attr.substring(0,attr.lastIndexOf("."));
//zeker niet leeg
if(realAttrName.equals("$prerequisites$")) { //collection
if (foreignAttr == null)
if (!outer)
mem.joinSet.add(
(String) mem.nameToAliasMapping.get(attr)
+ ".$refOID$="
+ thisAlias
+ ".$OID$");
else {
String attrAlias =
(String) mem.nameToAliasMapping.get(attr);
mem.outerJoinAliases.add(attrAlias);
mem.outerJoinAliases.add(thisAlias);
Vector tmp = new Vector();
tmp.add(thisAlias);
tmp.add(
attrAlias
+ ".$OID$="
+ thisAlias
+ ".$OID$");
mem.outerJoins.put(attrAlias, tmp);
}
else
mem.joinSet.add(
(String) mem.nameToAliasMapping.get(attr)
+".$prerequisites$"
+ "="
+ (String) mem.nameToAliasMapping.get(
foreignAttr)
+ ".$OID$");
//contains, ...
}
}

pointcut register_casestudy_Course(
MyMemoryQuery mem,
String thisType,
String variableName) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.register(
String,
String) throws JDOQueryException)
&& args(thisType, variableName)
&& if (thisType.equals("casestudy.Course"));
after(MyMemoryQuery mem, String thisType, String variableName) throws JDOQueryException: register_casestudy_Course(
mem,
thisType,
variableName) {
String newAlias = "alias" + (mem.aliasIndex++);
String realName = "";
int lastDot = variableName.lastIndexOf(".");
if (lastDot != -1)
realName = "$"+variableName.substring(lastDot + 1)+"$";
else
realName = variableName; //this/variable
if (realName.equals("$courseID$")
|| realName.equals("$courseName$")
|| realName.equals("$courseWeight$")) {
//doe niets (persistent wordt gedaan in this/variable van ander aspect)
}else if (realName.equals("$prerequisites$")) {
mem.aliasToTableMapping.put(newAlias, "alias1616369544");
mem.nameToAliasMapping.put(variableName, newAlias);
}else { //this/variable
mem.aliasToTableMapping.put(newAlias, "alias799232454");
mem.nameToAliasMapping.put(variableName, newAlias);
}
}

pointcut getCompTypes_casestudy_Course(
MyMemoryQuery mem,
String attr,
String thisType) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.getCompTypes(
String,
String))
&& args(attr, thisType)
&& if (thisType.equals("casestudy.Course"));
after(MyMemoryQuery mem, String attr, String thisType) : getCompTypes_casestudy_Course(
mem,
attr,
thisType) {
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
//zeker niet leeg
if (realAttrName.equals("$courseID$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$courseName$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$courseWeight$")) {
Vector res = new Vector();
res.add("int");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$prerequisites$")) {
Vector res = new Vector();
res.add("casestudy.Course");
mem.nameToCompTypeMapping.put(attr, res);
}else { //this/variable
Vector res = new Vector();
res.add("casestudy.Course");
mem.nameToCompTypeMapping.put(attr, res);
}
}
}
