
	package aspects.imp.casestudy;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Statement;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.Iterator;
	
	import java.lang.reflect.Constructor;
	import java.lang.reflect.InvocationTargetException;
	import java.lang.reflect.Modifier;
	
    import persistence.type.*;
    import com.sun.jdori.common.query.MyMemoryQuery;
    import com.sun.jdori.query.JDOQueryException;
  
  public privileged aspect Major_aspect{
  
pointcut writer_casestudy_Major(casestudy.Major obj): this(obj) && execution(public void persistence.type.Persistent.write() throws persistence.exceptions.WriteException);
after(casestudy.Major obj)  throws persistence.exceptions.WriteException: writer_casestudy_Major(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
stmt=connection.createStatement();
stmt.executeUpdate("insert into alias473470204 ($OID$, $majorID$, $department$, $faculty$) values ('"+obj.getOID().toString()+"', '"+obj.getMajorID()+"', '"+obj.getDepartment()+"', '"+obj.getFaculty()+"')");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.WriteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut updater_casestudy_Major(casestudy.Major obj): this(obj) && execution(public void persistence.type.Persistent.update() throws persistence.exceptions.UpdateException);
after(casestudy.Major obj) throws persistence.exceptions.UpdateException: updater_casestudy_Major(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=connection.createStatement();
Iterator it=null;
stmt=connection.createStatement();
stmt.executeUpdate("update alias473470204 set $majorID$='"+obj.getMajorID()+"', $department$='"+obj.getDepartment()+"', $faculty$='"+obj.getFaculty()+"' where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.UpdateException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut deleter_casestudy_Major(casestudy.Major obj): this(obj) && execution(public void persistence.type.Persistent.delete() throws persistence.exceptions.DeleteException);
after(casestudy.Major obj) throws persistence.exceptions.DeleteException: deleter_casestudy_Major(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=connection.createStatement();
stmt.executeUpdate("delete from alias473470204 where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.DeleteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut reader_casestudy_Major(ObjectID OID,boolean deep): args(OID,deep) && execution(public Object persistence.type.Persistent.QueryManager.read(ObjectID,boolean)) && if(OID.getCClass().equals("casestudy.Major"));
Object around(ObjectID OID,boolean deep): reader_casestudy_Major(OID,deep){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
ResultSet res=null;
stmt=connection.createStatement();
res=stmt.executeQuery("select * from alias473470204 where $OID$='"+OID.toString()+"'");
Object obj=null;
if(res.next()){
obj=persistence.Utilities.constructObject(OID);
persistence.type.ObjectIDFactory facobj0=new persistence.type.ObjectIDFactory();
persistence.type.ObjectID obj0=facobj0.translateToObjectID(OID.toString());
((casestudy.Major)obj).setOID(obj0);
java.lang.String obj1=new String(res.getString("$majorID$"));
((casestudy.Major)obj).setMajorID(obj1);
java.lang.String obj2=new String(res.getString("$department$"));
((casestudy.Major)obj).setDepartment(obj2);
java.lang.String obj3=new String(res.getString("$faculty$"));
((casestudy.Major)obj).setFaculty(obj3);
}
res.close();
stmt.close();
return obj;
}catch(Exception e){
//doe voorlopig niets en gebruik transactie-aspect
}finally{
conFac.closeConnection(connection);
}
return null;
}
pointcut getJoins_casestudy_Major(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : this(
mem)
&& call(
	private void com.sun.jdori.common.query.MyMemoryQuery.getJoins(
String,
String,
String,
boolean))
&& args(attr, thisType, foreignAttr, outer)
&& if (thisType.equals("casestudy.Major"));

	/**
* Enkel Collections, arrays, Maps en persistent <--> anders negeren
*/
after(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : getJoins_casestudy_Major(
mem,
attr,
thisType,
foreignAttr,
outer) {
//nesting: ontrafel echte naam attribuut door aliassen achterwaarts op te zoeken
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
String thisAlias=attr.substring(0,attr.lastIndexOf("."));
//zeker niet 
}

pointcut register_casestudy_Major(
MyMemoryQuery mem,
String thisType,
String variableName) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.register(
String,
String) throws JDOQueryException)
&& args(thisType, variableName)
&& if (thisType.equals("casestudy.Major"));
after(MyMemoryQuery mem, String thisType, String variableName) throws JDOQueryException: register_casestudy_Major(
mem,
thisType,
variableName) {
String newAlias = "alias" + (mem.aliasIndex++);
String realName = "";
int lastDot = variableName.lastIndexOf(".");
if (lastDot != -1)
realName = "$"+variableName.substring(lastDot + 1)+"$";
else
realName = variableName; //this/variable
if (realName.equals("$majorID$")
|| realName.equals("$department$")
|| realName.equals("$faculty$")) {
//doe niets (persistent wordt gedaan in this/variable van ander aspect)
}else { //this/variable
mem.aliasToTableMapping.put(newAlias, "alias473470204");
mem.nameToAliasMapping.put(variableName, newAlias);
}
}

pointcut getCompTypes_casestudy_Major(
MyMemoryQuery mem,
String attr,
String thisType) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.getCompTypes(
String,
String))
&& args(attr, thisType)
&& if (thisType.equals("casestudy.Major"));
after(MyMemoryQuery mem, String attr, String thisType) : getCompTypes_casestudy_Major(
mem,
attr,
thisType) {
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
//zeker niet leeg
if (realAttrName.equals("$majorID$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$department$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$faculty$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else { //this/variable
Vector res = new Vector();
res.add("casestudy.Major");
mem.nameToCompTypeMapping.put(attr, res);
}
}
}
