
	package aspects.imp.casestudy;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Statement;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.Iterator;
	
	import java.lang.reflect.Constructor;
	import java.lang.reflect.InvocationTargetException;
	import java.lang.reflect.Modifier;
	
    import persistence.type.*;
    import com.sun.jdori.common.query.MyMemoryQuery;
    import com.sun.jdori.query.JDOQueryException;
  
  public privileged aspect Student_aspect{
  
pointcut writer_casestudy_Student(casestudy.Student obj): this(obj) && execution(public void persistence.type.Persistent.write() throws persistence.exceptions.WriteException);
after(casestudy.Student obj)  throws persistence.exceptions.WriteException: writer_casestudy_Student(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
if(obj.getName()!=null) obj.getName().write();
if(obj.getAdres()!=null) obj.getAdres().write();
stmt=connection.createStatement();
stmt.executeUpdate("insert into alias1036744902 ($OID$, $name$, $studentID$, $yearOfStudy$, $adres$, $programOfStudy$) values ('"+obj.getOID().toString()+"', '"+((obj.getName()!=null)?obj.getName().getOID().toString():"null")+"', '"+obj.getStudentID()+"', '"+((obj.getYearOfStudy()!=null)?obj.getYearOfStudy().getOID().toString():"null")+"', '"+((obj.getAdres()!=null)?obj.getAdres().getOID().toString():"null")+"', '"+((obj.getProgramOfStudy()!=null)?obj.getProgramOfStudy().getOID().toString():"null")+"')");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.WriteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut updater_casestudy_Student(casestudy.Student obj): this(obj) && execution(public void persistence.type.Persistent.update() throws persistence.exceptions.UpdateException);
after(casestudy.Student obj) throws persistence.exceptions.UpdateException: updater_casestudy_Student(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
if(obj.getName()!=null) obj.getName().delete();
if(obj.getAdres()!=null) obj.getAdres().delete();
Statement stmt=connection.createStatement();
Iterator it=null;
if(obj.getName()!=null) obj.getName().write();
if(obj.getAdres()!=null) obj.getAdres().write();
stmt=connection.createStatement();
stmt.executeUpdate("update alias1036744902 set $name$='"+((obj.getName()!=null)?obj.getName().getOID().toString():"null")+"', $studentID$='"+obj.getStudentID()+"', $yearOfStudy$='"+((obj.getYearOfStudy()!=null)?obj.getYearOfStudy().getOID().toString():"null")+"', $adres$='"+((obj.getAdres()!=null)?obj.getAdres().getOID().toString():"null")+"', $programOfStudy$='"+((obj.getProgramOfStudy()!=null)?obj.getProgramOfStudy().getOID().toString():"null")+"' where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.UpdateException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut deleter_casestudy_Student(casestudy.Student obj): this(obj) && execution(public void persistence.type.Persistent.delete() throws persistence.exceptions.DeleteException);
after(casestudy.Student obj) throws persistence.exceptions.DeleteException: deleter_casestudy_Student(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
if(obj.getName()!=null) obj.getName().delete();
if(obj.getAdres()!=null) obj.getAdres().delete();
Statement stmt=connection.createStatement();
stmt.executeUpdate("delete from alias1036744902 where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.DeleteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut reader_casestudy_Student(ObjectID OID,boolean deep): args(OID,deep) && execution(public Object persistence.type.Persistent.QueryManager.read(ObjectID,boolean)) && if(OID.getCClass().equals("casestudy.Student"));
Object around(ObjectID OID,boolean deep): reader_casestudy_Student(OID,deep){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
ResultSet res=null;
stmt=connection.createStatement();
res=stmt.executeQuery("select * from alias1036744902 where $OID$='"+OID.toString()+"'");
Object obj=null;
if(res.next()){
obj=persistence.Utilities.constructObject(OID);
persistence.type.ObjectIDFactory facobj0=new persistence.type.ObjectIDFactory();
persistence.type.ObjectID obj0=facobj0.translateToObjectID(OID.toString());
((casestudy.Student)obj).setOID(obj0);
persistence.type.ObjectIDFactory facobj1=new persistence.type.ObjectIDFactory();
casestudy.Name obj1=null;
if(!res.getString("$name$").equalsIgnoreCase("null")){
if(!deep){
obj1=(casestudy.Name)persistence.Utilities.constructObject(facobj1.translateToObjectID(res.getString("$name$")));
obj1.setOID(facobj1.translateToObjectID(res.getString("$name$")));
}else{
obj1=(casestudy.Name)persistence.type.Persistent.QueryManager.read(facobj1.translateToObjectID(res.getString("$name$")),deep);
}}
((casestudy.Student)obj).setName(obj1);
java.lang.String obj2=new String(res.getString("$studentID$"));
((casestudy.Student)obj).setStudentID(obj2);
persistence.type.ObjectIDFactory facobj3=new persistence.type.ObjectIDFactory();
casestudy.Major obj3=null;
if(!res.getString("$yearOfStudy$").equalsIgnoreCase("null")){
if(!deep){
obj3=(casestudy.Major)persistence.Utilities.constructObject(facobj3.translateToObjectID(res.getString("$yearOfStudy$")));
obj3.setOID(facobj3.translateToObjectID(res.getString("$yearOfStudy$")));
}else{
obj3=(casestudy.Major)persistence.type.Persistent.QueryManager.read(facobj3.translateToObjectID(res.getString("$yearOfStudy$")),deep);
}}
((casestudy.Student)obj).setYearOfStudy(obj3);
persistence.type.ObjectIDFactory facobj4=new persistence.type.ObjectIDFactory();
casestudy.Address obj4=null;
if(!res.getString("$adres$").equalsIgnoreCase("null")){
if(!deep){
obj4=(casestudy.Address)persistence.Utilities.constructObject(facobj4.translateToObjectID(res.getString("$adres$")));
obj4.setOID(facobj4.translateToObjectID(res.getString("$adres$")));
}else{
obj4=(casestudy.Address)persistence.type.Persistent.QueryManager.read(facobj4.translateToObjectID(res.getString("$adres$")),deep);
}}
((casestudy.Student)obj).setAdres(obj4);
persistence.type.ObjectIDFactory facobj5=new persistence.type.ObjectIDFactory();
casestudy.Curriculum obj5=null;
if(!res.getString("$programOfStudy$").equalsIgnoreCase("null")){
if(!deep){
obj5=(casestudy.Curriculum)persistence.Utilities.constructObject(facobj5.translateToObjectID(res.getString("$programOfStudy$")));
obj5.setOID(facobj5.translateToObjectID(res.getString("$programOfStudy$")));
}else{
obj5=(casestudy.Curriculum)persistence.type.Persistent.QueryManager.read(facobj5.translateToObjectID(res.getString("$programOfStudy$")),deep);
}}
((casestudy.Student)obj).setProgramOfStudy(obj5);
}
res.close();
stmt.close();
return obj;
}catch(Exception e){
//doe voorlopig niets en gebruik transactie-aspect
}finally{
conFac.closeConnection(connection);
}
return null;
}
pointcut getJoins_casestudy_Student(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : this(
mem)
&& call(
	private void com.sun.jdori.common.query.MyMemoryQuery.getJoins(
String,
String,
String,
boolean))
&& args(attr, thisType, foreignAttr, outer)
&& if (thisType.equals("casestudy.Student"));

	/**
* Enkel Collections, arrays, Maps en persistent <--> anders negeren
*/
after(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : getJoins_casestudy_Student(
mem,
attr,
thisType,
foreignAttr,
outer) {
//nesting: ontrafel echte naam attribuut door aliassen achterwaarts op te zoeken
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
String thisAlias=attr.substring(0,attr.lastIndexOf("."));
//zeker niet leeg
if (realAttrName.equals("$name$")) { //persistent
//realAttrName moet vervangen worden door naam attribuut; enkel $OID$; foreignAttr altijd null (Persistent kan niets containen)
mem.joinSet.add(
thisAlias+"."+realAttrName
+ "="
+ (String) mem.nameToAliasMapping.get(attr)
+ ".$OID$");
//linking attribute with own class table
}else if (realAttrName.equals("$yearOfStudy$")) { //persistent
//realAttrName moet vervangen worden door naam attribuut; enkel $OID$; foreignAttr altijd null (Persistent kan niets containen)
mem.joinSet.add(
thisAlias+"."+realAttrName
+ "="
+ (String) mem.nameToAliasMapping.get(attr)
+ ".$OID$");
//linking attribute with own class table
}else if (realAttrName.equals("$adres$")) { //persistent
//realAttrName moet vervangen worden door naam attribuut; enkel $OID$; foreignAttr altijd null (Persistent kan niets containen)
mem.joinSet.add(
thisAlias+"."+realAttrName
+ "="
+ (String) mem.nameToAliasMapping.get(attr)
+ ".$OID$");
//linking attribute with own class table
}else if (realAttrName.equals("$programOfStudy$")) { //persistent
//realAttrName moet vervangen worden door naam attribuut; enkel $OID$; foreignAttr altijd null (Persistent kan niets containen)
mem.joinSet.add(
thisAlias+"."+realAttrName
+ "="
+ (String) mem.nameToAliasMapping.get(attr)
+ ".$OID$");
//linking attribute with own class table
}
}

pointcut register_casestudy_Student(
MyMemoryQuery mem,
String thisType,
String variableName) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.register(
String,
String) throws JDOQueryException)
&& args(thisType, variableName)
&& if (thisType.equals("casestudy.Student"));
after(MyMemoryQuery mem, String thisType, String variableName) throws JDOQueryException: register_casestudy_Student(
mem,
thisType,
variableName) {
String newAlias = "alias" + (mem.aliasIndex++);
String realName = "";
int lastDot = variableName.lastIndexOf(".");
if (lastDot != -1)
realName = "$"+variableName.substring(lastDot + 1)+"$";
else
realName = variableName; //this/variable
if (realName.equals("$name$")
|| realName.equals("$studentID$")
|| realName.equals("$yearOfStudy$")
|| realName.equals("$adres$")
|| realName.equals("$programOfStudy$")) {
//doe niets (persistent wordt gedaan in this/variable van ander aspect)
}else { //this/variable
mem.aliasToTableMapping.put(newAlias, "alias1036744902");
mem.nameToAliasMapping.put(variableName, newAlias);
}
}

pointcut getCompTypes_casestudy_Student(
MyMemoryQuery mem,
String attr,
String thisType) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.getCompTypes(
String,
String))
&& args(attr, thisType)
&& if (thisType.equals("casestudy.Student"));
after(MyMemoryQuery mem, String attr, String thisType) : getCompTypes_casestudy_Student(
mem,
attr,
thisType) {
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
//zeker niet leeg
if (realAttrName.equals("$name$")) {
Vector res = new Vector();
res.add("casestudy.Name");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$studentID$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$yearOfStudy$")) {
Vector res = new Vector();
res.add("casestudy.Major");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$adres$")) {
Vector res = new Vector();
res.add("casestudy.Address");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$programOfStudy$")) {
Vector res = new Vector();
res.add("casestudy.Curriculum");
mem.nameToCompTypeMapping.put(attr, res);
}else { //this/variable
Vector res = new Vector();
res.add("casestudy.Student");
mem.nameToCompTypeMapping.put(attr, res);
}
}
}
