/*
 * Created on 18-mrt-2004
 *
*/
package casestudy;

import java.util.Collection;

	/**
	 * @persistent
	 * @pversion major="01" minor="00"
	 */
public class Course {
	/**
	 * @persistent size="6"
	 * @accessor
	 */
	private String courseID;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private String courseName;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private int courseWeight;
	
	/**
	 * @persistent
	 * @accessor
	 * @content compType="casestudy.Course" contained="false"
	 */
	private Collection prerequisites;
	
	public Course(){
	}
	
	
	/**
	 * @return
	 */
	public String getCourseID() {
		return courseID;
	}

	/**
	 * @return
	 */
	public String getCourseName() {
		return courseName;
	}

	/**
	 * @return
	 */
	public int getCourseWeight() {
		return courseWeight;
	}

	/**
	 * @param string
	 */
	public void setCourseID(String string) {
		courseID = string;
	}

	/**
	 * @param string
	 */
	public void setCourseName(String string) {
		courseName = string;
	}

	/**
	 * @param i
	 */
	public void setCourseWeight(int i) {
		courseWeight = i;
	}

	/**
	 * @return
	 */
	public Collection getPrerequisites() {
		return prerequisites;
	}

	/**
	 * @param collection
	 */
	public void setPrerequisites(Collection collection) {
		prerequisites = collection;
	}

}
