/*
 * Created on 18-mrt-2004
 *
*/
package casestudy;

import java.util.Collection;
import java.util.Iterator;

	/**
	 * @persistent
	 * @pversion major="01" minor="00"
	 */
public class Curriculum {
	/**
	 * @persistent
	 * @accessor
	 */
	private int high;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private int low;
	
	private int runningTotal;
	
	/**
	 * @persistent 
	 * @content compType="casestudy.Course" contained="false"
	 */
	private Collection courses;
	
	public Curriculum(){
	}
	
	/**
	 * @return
	 */
	public Collection getCourses() {
		return courses;
	}

	/**
	 * @return
	 */
	public int getHigh() {
		return high;
	}

	/**
	 * @return
	 */
	public int getLow() {
		return low;
	}

	/**
	 * @return
	 */
	public int getRunningTotal() {
		return runningTotal;
	}

	/**
	 * @param collection
	 */
	public void setCourses(Collection collection) {
		courses = collection;
		Iterator it=collection.iterator();
		runningTotal=0;		
		while(it.hasNext()){
			runningTotal+=((Course)it.next()).getCourseWeight();
		}
	}

	/**
	 * @param i
	 */
	public void setHigh(int i) {
		high = i;
	}

	/**
	 * @param i
	 */
	public void setLow(int i) {
		low = i;
	}

	
}
