package casestudy;
import java.util.Collection;


	/**
	 * @persistent
	 * @pversion major="01" minor="00"
	 */
public class Student{

	/**
	 * @persistent contained="uni"
	 * @accessor
	 */
	private Name name;
		
	/**
	 * @persistent size="8"
	 * @accessor
	 */
	private String studentID;
		
	/**
	 * @persistent contained="false"
	 * @accessor
	 */
	private Major yearOfStudy;
	
	/**
	 * @persistent contained="uni"
	 * @accessor 
	 */
	private Address adres;
	
		
	/**
	 * @persistent contained="false"
	 * @accessor
	 */
	private Curriculum programOfStudy;
		
	public Student(){
	}
		


	
	/**
	 * @return
	 */
	public Curriculum getProgramOfStudy() {
		return programOfStudy;
	}

	/**
	 * @return
	 */
	public String getStudentID() {
		return studentID;
	}

	/**
	 * @return
	 */
	public Major getYearOfStudy() {
		return yearOfStudy;
	}

	

	/**
	 * @param collection
	 */
	public void setProgramOfStudy(Curriculum collection) {
		programOfStudy = collection;
	}

	/**
	 * @param string
	 */
	public void setStudentID(String string) {
		studentID = string;
	}

	/**
	 * @param i
	 */
	public void setYearOfStudy(Major i) {
		yearOfStudy = i;
	}

	/**
	 * @return
	 */
	public Address getAdres() {
		return adres;
	}

	/**
	 * @param address
	 */
	public void setAdres(Address address) {
		adres = address;
	}

	/**
	 * @return
	 */
	public Name getName() {
		return name;
	}

	/**
	 * @param name
	 */
	public void setName(Name name) {
		this.name = name;
	}

}

