/*
 * Created on 6-mrt-2004
 *
*/
package javapro;

import java.util.HashSet;

/**
 * @author bram
 * @persistent
 * @pversion major="01"
 *
 * 6-mrt-2004
 */
public class Department {
	/**
	 * @persistent
	 * @accessor
	 */
	private long        deptid;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private String      name;
	
	/**
	 * @persistent
	 * @accessor
	 * @content compType="javapro.Employee" contained="false"
	 */
	private HashSet     employees;//element:Employee
	
	/**
	 * @persistent
	 * @accessor
	 * @content compType="javapro.Project" contained="false"
	 */
	private HashSet     projects;//element:Project
	
	public Department(){
		deptid=0L;
		name="";
		employees=null;
		projects=null;
	}

	/**
	 * @return
	 */
	public long getDeptid() {
		return deptid;
	}

	/**
	 * @return
	 */
	public HashSet getEmployees() {
		return employees;
	}

	/**
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return
	 */
	public HashSet getProjects() {
		return projects;
	}

	/**
	 * @param l
	 */
	public void setDeptid(long l) {
		deptid = l;
	}

	/**
	 * @param set
	 */
	public void setEmployees(HashSet set) {
		employees = set;
	}

	/**
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}

	/**
	 * @param set
	 */
	public void setProjects(HashSet set) {
		projects = set;
	}

}
