/*
 * Created on 12-apr-2004
 *
*/
package persistence.transaction;

import java.util.Date;

/**
 * Eenvoudige implementatie van supertransactie. In {@link persistence.type.Persistent interface
 * Persistent} wordt het gebruik ervan duidelijk: men kan TransactionImpl als een sessie zien die
 * men opent en sluit.
 * @author bram
 *
 * 12-apr-2004
 */
public class TransactionImpl implements Transaction {
	private long id = (new Date()).getTime();

	/**
	 * @see persistence.transaction.Transaction#getTransactionID()
	 */
	public String getTransactionID() {
		return id + "";
	}

	/**
	 * @see persistence.transaction.Transaction#commit()
	 */
	public void commit() {
	}

	/**
	 * @see persistence.transaction.Transaction#start()
	 */
	public void start() {
	}

	/**
	 * @see persistence.transaction.Transaction#rollback()
	 */
	public void rollback() {
	}

	/**
	 * @see persistence.transaction.Transaction#isActive()
	 */
	public boolean isActive() {
		return false;
	}

}
