/*
 * Created on 30-okt-2003
 *
*/
package persistence.visitor;

import persistence.table.*;
import persistence.table.*;

/**
 * Visitor for TableComponent-hierarchy which imposes order of traversal itself.
 * @author bram
 *
 * 30-okt-2003
 */
public interface TableComponentVisitor {
	public void visitAttribute(Attribute attr);
	public void visitReferenceAttribute(ReferenceAttribute refAttr);
	public void visitTable(Table table);	
	public void visitArrayTable(ArrayTable ar);
	public void visitCollectionTable(CollectionTable coll);
	public void visitMapTable(MapTable map);	
	public String getResult();

}
