import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.dialect.Dialect;

import persistence.DatabaseConnection;

/**
 * 
 * @author bram
 *
 * 25-mei-2004
 */
public class Script{
	private static Connection conn=null;
	private static Dialect _d_i_a_l_e_c_t_=null;

	public static void main(String argv []){
		Properties props=new Properties();
		try {
						InputStream in=new BufferedInputStream(new FileInputStream("./db.properties"));
						props.load(in);
						conn=(new DatabaseConnection(props)).getConn();
						_d_i_a_l_e_c_t_=Dialect.getDialect(props);
		} catch (ClassNotFoundException e) {			
			e.printStackTrace();
		} catch (SQLException e) {			
			e.printStackTrace();
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		} catch (IOException e) {			
			e.printStackTrace();
		} catch(HibernateException e){
			e.printStackTrace();
		}
		System.out.println("Drop oude versie");
		drop();
		System.out.println("Create nieuwe versie");
		create();
	}
	
	public static void create(){	
		Statement stmt=null;
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1885285125 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$street$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$city$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$zip$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$number$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1885285125 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1885285125 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near casestudy.Address!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1195408363 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION3$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION4$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$drieD$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1195408363 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION1$, $POSITION2$, $POSITION3$, $POSITION4$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1542344954 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$coll$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1542344954 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refPOSITION$, $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias2040658249 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias2040658249 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1469921556 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refKEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$map$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1469921556 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refKEY$, $POSITION1$, $POSITION2$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias481185175 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$KEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias481185175 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $KEY$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias288103322 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$anInt$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$aString$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$aDouble$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$persObj$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias288103322 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias288103322 ($OID$, $persObj$) values ('null', 'null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.PrimitiveClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1021667645 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL) TYPE=InnoDB");
stmt.executeUpdate("alter table alias1021667645 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1021667645 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.PrimitiveClass.TestClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias58999776 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL) TYPE=InnoDB");
stmt.executeUpdate("alter table alias58999776 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias58999776 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.PrimitiveClass.TestClass.InnerTestClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1413969687 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$anInt$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1413969687 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1413969687 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.PrimitiveClass.NestedClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias898057200 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$members$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias898057200 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias728569514 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$name$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$budget$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias728569514 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias728569514 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near javapro.Project!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1959567594 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$projects$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1959567594 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1716917701 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$empid$ "+_d_i_a_l_e_c_t_.getTypeName(-5,-1)+",$firstname$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$lastname$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$address$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+",$birthdate$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$hiredate$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$salary$ "+_d_i_a_l_e_c_t_.getTypeName(7,-1)+",$department$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+",$manager$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1716917701 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1716917701 ($OID$, $address$, $department$, $manager$) values ('null', 'null', 'null', 'null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near javapro.Employee!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1343662806 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$firstName$ "+_d_i_a_l_e_c_t_.getTypeName(12,20)+",$lastName$ "+_d_i_a_l_e_c_t_.getTypeName(12,30)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1343662806 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1343662806 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near casestudy.Name!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1951078853 ( $refrefrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refrefPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refKEY$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$ar$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1951078853 add primary key($refrefrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refrefPOSITION$, $refKEY$("+((_d_i_a_l_e_c_t_.maxKeySize()>256)?256:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias748176541 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$KEY$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+" NOT NULL) TYPE=InnoDB");
stmt.executeUpdate("alter table alias748176541 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refPOSITION$, $KEY$("+((_d_i_a_l_e_c_t_.maxKeySize()>256)?256:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias2110673275 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias2110673275 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias2110680839 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$in$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias2110680839 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION1$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias358047395 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$inn$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias358047395 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias358047395 ($OID$, $inn$) values ('null', 'null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.PersistentClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table uitzondering ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$j$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table uitzondering add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into uitzondering ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.PersistentClass.PersistentInnerClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias792964054 ( $refrefrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refrefPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$rij$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias792964054 add primary key($refrefrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refrefPOSITION$, $refPOSITION1$, $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias177128278 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias177128278 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refPOSITION$, $POSITION1$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias688936830 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias688936830 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias2072642478 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$notInherited$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias2072642478 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias2072642478 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.ChildPersistentClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias53286575 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$street$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$city$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$state$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$zipcode$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias53286575 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias53286575 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near javapro.Address!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1036744902 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$name$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+",$studentID$ "+_d_i_a_l_e_c_t_.getTypeName(12,8)+",$yearOfStudy$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+",$adres$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+",$programOfStudy$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1036744902 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1036744902 ($OID$, $name$, $yearOfStudy$, $adres$, $programOfStudy$) values ('null', 'null', 'null', 'null', 'null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near casestudy.Student!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias473470204 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$majorID$ "+_d_i_a_l_e_c_t_.getTypeName(12,8)+",$department$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$faculty$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias473470204 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias473470204 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near casestudy.Major!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias437735757 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$courses$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias437735757 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias332108122 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$high$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$low$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias332108122 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias332108122 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near casestudy.Curriculum!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1616369544 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$prerequisites$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1616369544 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias799232454 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$courseID$ "+_d_i_a_l_e_c_t_.getTypeName(12,6)+",$courseName$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+",$courseWeight$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias799232454 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias799232454 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near casestudy.Course!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias657434749 ( $refrefrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refrefKEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$refPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$map$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias657434749 add primary key($refrefrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refrefKEY$, $refPOSITION$, $POSITION1$, $POSITION2$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias2024277114 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refKEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias2024277114 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refKEY$, $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias704649481 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$KEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias704649481 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $KEY$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias2013118740 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refPOSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$coll$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias2013118740 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refPOSITION$, $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias378117143 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias378117143 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1108953562 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$array$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1108953562 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION1$, $POSITION2$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias265916824 ( $refrefrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refrefPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refrefPOSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refKEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$mapArray$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias265916824 add primary key($refrefrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refrefPOSITION1$, $refrefPOSITION2$, $refKEY$, $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1038108556 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refPOSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$KEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1038108556 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refPOSITION1$, $refPOSITION2$, $KEY$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1769286168 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1769286168 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION1$, $POSITION2$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias919964984 ( $refrefrefrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refrefrefPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refrefrefPOSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refrefKEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$refPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$dubbeleMapArray$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias919964984 add primary key($refrefrefrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refrefrefPOSITION1$, $refrefrefPOSITION2$, $refrefKEY$, $refPOSITION1$, $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1699378925 ( $refrefrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refrefPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refrefPOSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refKEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+",$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1699378925 add primary key($refrefrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refrefPOSITION1$, $refrefPOSITION2$, $refKEY$, $POSITION1$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1913951582 ( $refrefOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$refPOSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$refPOSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$KEY$ "+_d_i_a_l_e_c_t_.getTypeName(8,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1913951582 add primary key($refrefOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $refPOSITION1$, $refPOSITION2$, $KEY$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias235694167 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION1$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$POSITION2$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias235694167 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION1$, $POSITION2$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1795256332 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL) TYPE=InnoDB");
stmt.executeUpdate("alter table alias1795256332 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1795256332 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near testApp.testPackage.PersistentClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1191056357 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$employees$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1191056357 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias384483186 ( $refOID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$POSITION$ "+_d_i_a_l_e_c_t_.getTypeName(4,-1)+",$projects$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias384483186 add primary key($refOID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"), $POSITION$)");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("create table alias1006596703 ( $OID$ "+_d_i_a_l_e_c_t_.getTypeName(12,1000)+" NOT NULL,$deptid$ "+_d_i_a_l_e_c_t_.getTypeName(-5,-1)+",$name$ "+_d_i_a_l_e_c_t_.getTypeName(12,256)+") TYPE=InnoDB");
stmt.executeUpdate("alter table alias1006596703 add primary key($OID$("+((_d_i_a_l_e_c_t_.maxKeySize()>1000)?1000:_d_i_a_l_e_c_t_.maxKeySize())+"))");
stmt.executeUpdate("insert into alias1006596703 ($OID$) values ('null')");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Create-problem near javapro.Department!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

			
	}
	
	public static void drop(){
		Statement stmt=null;
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1885285125 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near casestudy.Address!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1195408363 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1542344954 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias2040658249 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1469921556 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias481185175 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias288103322 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.PrimitiveClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1021667645 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.PrimitiveClass.TestClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias58999776 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.PrimitiveClass.TestClass.InnerTestClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1413969687 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.PrimitiveClass.NestedClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias898057200 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias728569514 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near javapro.Project!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1959567594 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1716917701 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near javapro.Employee!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1343662806 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near casestudy.Name!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1951078853 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias748176541 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias2110673275 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias2110680839 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias358047395 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.PersistentClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table uitzondering "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.PersistentClass.PersistentInnerClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias792964054 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias177128278 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias688936830 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias2072642478 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.ChildPersistentClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias53286575 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near javapro.Address!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1036744902 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near casestudy.Student!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias473470204 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near casestudy.Major!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias437735757 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias332108122 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near casestudy.Curriculum!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1616369544 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias799232454 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near casestudy.Course!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias657434749 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias2024277114 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias704649481 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias2013118740 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias378117143 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1108953562 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias265916824 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1038108556 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1769286168 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias919964984 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1699378925 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1913951582 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias235694167 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1795256332 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near testApp.testPackage.PersistentClass!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

		
		try{
conn.setAutoCommit(false);
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1191056357 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias384483186 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
stmt=conn.createStatement();
stmt.executeUpdate("drop table alias1006596703 "+_d_i_a_l_e_c_t_.getCascadeConstraintsString()+"");
stmt.close();
conn.setAutoCommit(true);
}catch(Exception e){
try{
System.out.println("Drop-problem near javapro.Department!");
e.printStackTrace();
conn.rollback();
conn.setAutoCommit(true);
}catch(SQLException s){
s.printStackTrace();
}
}

			
	}
}


