
	package aspects.imp.casestudy;
  
	import java.io.BufferedInputStream;
	import java.io.FileInputStream;
	import java.io.FileNotFoundException;
	import java.io.IOException;
	import java.io.InputStream;
	import java.sql.SQLException;
	import java.sql.Statement;
	import java.sql.Connection;
	import java.sql.ResultSet;
	import java.util.Properties;
	import java.util.Vector;
	import java.util.Iterator;
	
	import java.lang.reflect.Constructor;
	import java.lang.reflect.InvocationTargetException;
	import java.lang.reflect.Modifier;
	
    import persistence.type.*;
    import com.sun.jdori.common.query.MyMemoryQuery;
    import com.sun.jdori.query.JDOQueryException;
  
  public privileged aspect Address_aspect{
  
pointcut writer_casestudy_Address(casestudy.Address obj): this(obj) && execution(public void persistence.type.Persistent.write() throws persistence.exceptions.WriteException);
after(casestudy.Address obj)  throws persistence.exceptions.WriteException: writer_casestudy_Address(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
stmt=connection.createStatement();
stmt.executeUpdate("insert into alias1885285125 ($OID$, $street$, $city$, $zip$, $number$) values ('"+obj.getOID().toString()+"', '"+obj.getStreet()+"', '"+obj.getCity()+"', '"+obj.getZip()+"', "+obj.getNumber()+")");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.WriteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut updater_casestudy_Address(casestudy.Address obj): this(obj) && execution(public void persistence.type.Persistent.update() throws persistence.exceptions.UpdateException);
after(casestudy.Address obj) throws persistence.exceptions.UpdateException: updater_casestudy_Address(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=connection.createStatement();
Iterator it=null;
stmt=connection.createStatement();
stmt.executeUpdate("update alias1885285125 set $street$='"+obj.getStreet()+"', $city$='"+obj.getCity()+"', $zip$='"+obj.getZip()+"', $number$="+obj.getNumber()+" where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.UpdateException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut deleter_casestudy_Address(casestudy.Address obj): this(obj) && execution(public void persistence.type.Persistent.delete() throws persistence.exceptions.DeleteException);
after(casestudy.Address obj) throws persistence.exceptions.DeleteException: deleter_casestudy_Address(obj){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=connection.createStatement();
stmt.executeUpdate("delete from alias1885285125 where $OID$='"+obj.getOID().toString()+"'");
stmt.close();
}catch(Exception e){
throw new persistence.exceptions.DeleteException(obj.getOID().toString(),e);
}finally{
conFac.closeConnection(connection);
}
}
pointcut reader_casestudy_Address(ObjectID OID,boolean deep): args(OID,deep) && execution(public Object persistence.type.Persistent.QueryManager.read(ObjectID,boolean)) && if(OID.getCClass().equals("casestudy.Address"));
Object around(ObjectID OID,boolean deep): reader_casestudy_Address(OID,deep){
ConnectionFactory conFac=new ConnectionFactory();
Connection connection=conFac.getConnection();
try{
Statement stmt=null;
Iterator it=null;
ResultSet res=null;
stmt=connection.createStatement();
res=stmt.executeQuery("select * from alias1885285125 where $OID$='"+OID.toString()+"'");
Object obj=null;
if(res.next()){
obj=persistence.Utilities.constructObject(OID);
persistence.type.ObjectIDFactory facobj0=new persistence.type.ObjectIDFactory();
persistence.type.ObjectID obj0=facobj0.translateToObjectID(OID.toString());
((casestudy.Address)obj).setOID(obj0);
java.lang.String obj1=new String(res.getString("$street$"));
((casestudy.Address)obj).setStreet(obj1);
java.lang.String obj2=new String(res.getString("$city$"));
((casestudy.Address)obj).setCity(obj2);
java.lang.String obj3=new String(res.getString("$zip$"));
((casestudy.Address)obj).setZip(obj3);
int obj4=res.getInt("$number$");
((casestudy.Address)obj).setNumber(obj4);
}
res.close();
stmt.close();
return obj;
}catch(Exception e){
//doe voorlopig niets en gebruik transactie-aspect
}finally{
conFac.closeConnection(connection);
}
return null;
}
pointcut getJoins_casestudy_Address(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : this(
mem)
&& call(
	private void com.sun.jdori.common.query.MyMemoryQuery.getJoins(
String,
String,
String,
boolean))
&& args(attr, thisType, foreignAttr, outer)
&& if (thisType.equals("casestudy.Address"));

	/**
* Enkel Collections, arrays, Maps en persistent <--> anders negeren
*/
after(
MyMemoryQuery mem,
String attr,
String thisType,
String foreignAttr,
boolean outer) : getJoins_casestudy_Address(
mem,
attr,
thisType,
foreignAttr,
outer) {
//nesting: ontrafel echte naam attribuut door aliassen achterwaarts op te zoeken
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
String thisAlias=attr.substring(0,attr.lastIndexOf("."));
//zeker niet 
}

pointcut register_casestudy_Address(
MyMemoryQuery mem,
String thisType,
String variableName) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.register(
String,
String) throws JDOQueryException)
&& args(thisType, variableName)
&& if (thisType.equals("casestudy.Address"));
after(MyMemoryQuery mem, String thisType, String variableName) throws JDOQueryException: register_casestudy_Address(
mem,
thisType,
variableName) {
String newAlias = "alias" + (mem.aliasIndex++);
String realName = "";
int lastDot = variableName.lastIndexOf(".");
if (lastDot != -1)
realName = "$"+variableName.substring(lastDot + 1)+"$";
else
realName = variableName; //this/variable
if (realName.equals("$street$")
|| realName.equals("$city$")
|| realName.equals("$number$")) {
//doe niets (persistent wordt gedaan in this/variable van ander aspect)
}else if (realName.equals("$zip$")) { //no accessor!
throw new JDOQueryException("Attribute zip in type casestudy.Address is no accessor!");
}else { //this/variable
mem.aliasToTableMapping.put(newAlias, "alias1885285125");
mem.nameToAliasMapping.put(variableName, newAlias);
}
}

pointcut getCompTypes_casestudy_Address(
MyMemoryQuery mem,
String attr,
String thisType) : this(
mem)
&& call(
private void com.sun.jdori.common.query.MyMemoryQuery.getCompTypes(
String,
String))
&& args(attr, thisType)
&& if (thisType.equals("casestudy.Address"));
after(MyMemoryQuery mem, String attr, String thisType) : getCompTypes_casestudy_Address(
mem,
attr,
thisType) {
String realAttrName = "$"+attr.substring(attr.lastIndexOf(".") + 1)+"$";
//zeker niet leeg
if (realAttrName.equals("$street$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$city$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$zip$")) {
Vector res = new Vector();
res.add("java.lang.String");
mem.nameToCompTypeMapping.put(attr, res);
}else if (realAttrName.equals("$number$")) {
Vector res = new Vector();
res.add("int");
mem.nameToCompTypeMapping.put(attr, res);
}else { //this/variable
Vector res = new Vector();
res.add("casestudy.Address");
mem.nameToCompTypeMapping.put(attr, res);
}
}
}
