/*
 * Created on 6-mrt-2004
 *
*/
package javapro;

import java.math.BigDecimal;
import java.util.HashSet;

/**
 * @author bram
 * @persistent
 * @pversion major="01"
 *
 * 6-mrt-2004
 */
public class Project {
	/**
	 * @persistent
	 * @accessor
	 */
	private String      name;
	
	/**
	 * @persistent
	 * @accessor
	 */
	private int  budget;
	
	/**
	 * @persistent
	 * @accessor
	 * @content compType="javapro.Employee" contained="false"
	 */
	private HashSet     members;//element:Employee
	
	public Project(){
		name="";
		budget=0;
		members=null;
	}
	
	/**
	 * @return
	 */
	public int getBudget() {
		return budget;
	}

	/**
	 * @return
	 */
	public HashSet getMembers() {
		return members;
	}

	/**
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param decimal
	 */
	public void setBudget(int decimal) {
		budget = decimal;
	}

	/**
	 * @param set
	 */
	public void setMembers(HashSet set) {
		members = set;
	}

	/**
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}

}
