/*
 * Created on 30-okt-2003
 *
*/
package persistence.table;

import java.util.Collection;

import persistence.visitor.TableComponentVisitor;

/**
 * Tabel voor Collection.
 * @author bram
 *
 * 30-okt-2003
 */
public class CollectionTable extends Table {

	/**
	 * 
	 */
	public CollectionTable() {
		super("$refOID$");
		TableComponent position = new Attribute();
		position.addProperty("key", "true");
		position.setComponentName("POSITION");
		position.setJavaTypeName("int");
		add(position);
	}

	public CollectionTable(Collection FKeys) {
		super(FKeys);
		TableComponent position = new Attribute();
		position.addProperty("key", "true");
		position.setComponentName("POSITION");
		position.setJavaTypeName("int");
		add(position);
	}

	/**
	 * @see persistence.TableComponent#accept(persistence.TableComponentVisitor)
	 */
	public void accept(TableComponentVisitor visitor) {
		visitor.visitCollectionTable(this);
	}

}
