/*
 * Created on 30-okt-2003
 *
*/
package persistence.table;

import java.util.Collection;

import persistence.visitor.TableComponentVisitor;

/**
 * Tabel voor Map.
 * @author bram
 *
 * 30-okt-2003
 */
public class MapTable extends Table {

	/**
	 * Only column for $OID$ &lt;--&gt; no key-column. 
	 */
	public MapTable() {
		super("refOID");

	}

	public MapTable(Collection FKeys) {
		super(FKeys);
	}

	/**
	 * @see persistence.TableComponent#accept(persistence.TableComponentVisitor)
	 */
	public void accept(TableComponentVisitor visitor) {
		visitor.visitMapTable(this);

	}
}
