/*
 * Created on 24-okt-2003
 *
*/
package testApp;

import java.util.Collection;
import java.util.Map;

/**
 * @persistent
 * @pversion major="1"
 * @author bram
 *
 * 24-okt-2003
 */
public class PrimitiveClass {
	
	/**
	 * @persistent
	 * @pversion major="58"
	 * @author bram
	 *
	 * 14-feb-2004
	 */
	private class TestClass{
		/**
		 * @persistent
		 * @pversion major="666" minor="333"
		 */
		protected class InnerTestClass{
		}
	}
	
	
	/**
	 * @persistent	 
	 */
	private int anInt;
	/**
	 * @persistent
	 * @set setAWeirdString
	 */
	private String aString;
	/**
	 * @persistent
	 * @get getAWeirdDouble
	 */
	private double aDouble;
	/**
	 * @get aFalseEntry
	 */
	private Float aFloat;
	
	/**
	 * @persistent	 
	 */
	private int[][][][] drieD;
	
	/**
	 * @persistent contained="false"	 
	 */
	private PersistentClass persObj;
	
	/**
	 * @persistent
	 * @content compType="java.util.Collection" impClass="java.util.HashSet"
	 * @content compType="testApp.PersistentClass" contained="false"
	 */
	private Collection coll;
	
	/**
	 * @persistent
	 * @content compType="int[][]" compTypeKey="Double"	 
	 */
	private Map map;
	
	public PrimitiveClass(){
	}
	
	/**
	 * @persistent
	 * @pversion major="15"
	 * @author bram
	 *
	 * 24-okt-2003
	 */
	protected static class NestedClass{
		/**
		 * @persistent
		 */
		private int anInt;
		
		public NestedClass(){
		}
		
		public int getAnInt(){
			return anInt;
		}
		
		public void setAnInt(int in){
			anInt=in;
		}
	}

	/**
	 * @return
	 */
	public double getAWeirdDouble() {
		return aDouble;
	}

	/**
	 * @return
	 */
	public Float getAFloat() {
		return aFloat;
	}

	/**
	 * @return
	 */
	public int getAnInt() {
		return anInt;
	}

	/**
	 * @return
	 */
	public String getAString() {
		return aString;
	}

	/**
	 * @param d
	 */
	public void setADouble(double d) {
		aDouble = d;
	}

	/**
	 * @param f
	 */
	public void setAFloat(Float f) {
		aFloat = f;
	}

	/**
	 * @param i
	 */
	public void setAnInt(int i) {
		anInt = i;
	}

	/**
	 * @param string
	 */
	public void setAWeirdString(String string) {
		aString = string;
	}

	/**
	 * @return
	 */
	public int[][][][] getDrieD() {
		return drieD;
	}

	/**
	 * @param is
	 */
	public void setDrieD(int[][][][] is) {
		drieD = is;
	}

	/**
	 * @return
	 */
	public Collection getColl() {
		return coll;
	}

	/**
	 * @param collection
	 */
	public void setColl(Collection collection) {
		coll = collection;
	}

	/**
	 * @return
	 */
	public Map getMap() {
		return map;
	}

	/**
	 * @param map
	 */
	public void setMap(Map map) {
		this.map = map;
	}

	/**
	 * @return
	 */
	public PersistentClass getPersObj() {
		return persObj;
	}
	

	/**
	 * @param class1
	 */
	public void setPersObj(PersistentClass class1) {
		persObj = class1;
	}

}
