/*
 * Created on 29-sep-2003
 *
*/
package testApp.testPackage;

import java.util.Collection;
import java.util.Map;

import testApp.PrimitiveClass;



/**
 * @author bram
 *
 *@persistent
 *@pversion major="13"
 * 29-sep-2003
 */
public class PersistentClass {
	/**
	 * @persistent
	 * @content compType="java.util.Collection" compTypeKey="Double" impClass="java.util.HashSet"
	 * @content compType="int[][]"
	 */
	private Map map;
	
	/**
	 * @persistent impClass="java.util.HashSet"
	 * @content compType="java.util.Collection"
	 * @content compType="testApp.PersistentClass" contained="false"
	 */
	private Collection coll;
	
	/**
	 * @persistent contained="false"
	 */
	private PrimitiveClass[][] array;
	
	/**
	 * @persistent
	 * @content compType="java.util.Collection" compTypeKey="Double" impClass="java.util.HashSet"
	 * @content compType="Double" 
	 */
	private Map[][] mapArray;
	
	/**
	 * @persistent
	 * @content compType="java.util.Collection[]" compTypeKey="Double" impClass="java.util.HashSet"
	 * @content compType="Double"
	 */
	private Map[][] dubbeleMapArray;

	/**
	 * @return
	 */
	public PrimitiveClass[][] getArray() {
		return array;
	}

	/**
	 * @return
	 */
	public Collection getColl() {
		return coll;
	}

	/**
	 * @return
	 */
	public Map[][] getDubbeleMapArray() {
		return dubbeleMapArray;
	}

	/**
	 * @return
	 */
	public Map getMap() {
		return map;
	}

	/**
	 * @return
	 */
	public Map[][] getMapArray() {
		return mapArray;
	}

	/**
	 * @param classes
	 */
	public void setArray(PrimitiveClass[][] classes) {
		array = classes;
	}

	/**
	 * @param collection
	 */
	public void setColl(Collection collection) {
		coll = collection;
	}

	/**
	 * @param maps
	 */
	public void setDubbeleMapArray(Map[][] maps) {
		dubbeleMapArray = maps;
	}

	/**
	 * @param map
	 */
	public void setMap(Map map) {
		this.map = map;
	}

	/**
	 * @param maps
	 */
	public void setMapArray(Map[][] maps) {
		mapArray = maps;
	}

}
