package tests;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import javax.jdo.Query;

import persistence.type.ObjectID;
import persistence.type.Persistent;

import com.sun.jdori.common.query.MyQueryImpl;

import junit.framework.TestCase;
import casestudy.Address;
import casestudy.Course;
import casestudy.Curriculum;
import casestudy.Major;
import casestudy.Name;
import casestudy.Student;

/*
 * Created on 19-mrt-2004
 *
*/

/**
 * @author bram
 *
 * 19-mrt-2004
 */
public class TestMain extends TestCase {
	private long prev=0L;
	private long curr=0L;
	Collection collec=new ArrayList();
	
	ObjectID id=null;
	/**
	 * Constructor for TestMain.
	 * @param arg0
	 */
	public TestMain(String arg0) {
		super(arg0);
	}
	
	public void testQueries(){
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();		
		Student stu=(Student)Persistent.QueryManager.read(id,true);
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
		Iterator it=collec.iterator();
		while(it.hasNext()){
			System.out.println((Long)it.next());
		}
		/*String filter =
						"prerequisites.isEmpty()";
		Query query = new MyQueryImpl(null);//pm.newQuery(extent, filter);
				query.setClass(Course.class);
					query.declareImports("import casestudy.Course");
		/*String filter =
				"name.firstName.startsWith(firstNam) && " +
				//"adres.city == \"Waregem\" && " +				
		        "adres.zip == \"8790\" && " +
				"programOfStudy.courses.contains(cou) && " +
				"cou.prerequisites.contains(preReq) && " +
				"preReq.courseName == \"Analyse I\"";
				
			//Extent extent = pm.getExtent(
		   //	 Employee.class, true);
		 
		 
			//Query query = pm.newQuery(extent, filter);
	 
			Query query = new MyQueryImpl(null);//pm.newQuery(extent, filter);
		query.setClass(Student.class);
			query.declareImports("import casestudy.Course");
			query.declareVariables("casestudy.Course cou; casestudy.Course preReq");
			query.declareParameters(
				"String firstNam");
			/*query.setOrdering(
				"department.deptid ascending, salary descending");NIET gebruikt?*/
			/*query.setFilter(filter);
			
			/*Collection result = (Collection)query.execute(
				"Bra");*/				
		/*Collection result = (Collection)query.execute();
		/*		assertEquals(1,result.size());
		System.out.println(result.toArray()[0]);
		    Iterator iter = result.iterator();
			while( iter.hasNext() ){
				ObjectID id = (ObjectID) iter.next();
				Student emp=(Student)Persistent.QueryManager.read(id,true);
				assertEquals("19991539",emp.getStudentID());

			}*/
		/*	query.close(result);*/
	}
	
	

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		//Script.main(null);//drop and create tables
		prev=new Date().getTime();
		Course cou = new Course();
		cou.setCourseID("ANALY1");
		cou.setCourseName("Analyse I");
		cou.setCourseWeight(10);
		Course analysOne = cou;
		cou.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();

		cou = new Course();
		cou.setCourseID("ANALY2");
		cou.setCourseName("Analyse II");
		cou.setCourseWeight(8);
		Collection coll = new Vector();
		coll.add(analysOne);
		cou.setPrerequisites(coll);
		Course analysTwo = cou;
		cou.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
		
		cou = new Course();
		cou.setCourseID("ANALY3");
		cou.setCourseName("Analyse III");
		cou.setCourseWeight(8);
		coll = new Vector();
		coll.add(analysOne);
		coll.add(analysTwo);
		cou.setPrerequisites(coll);
		Course analysThree = cou;
		cou.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
		
		cou = new Course();
		cou.setCourseID("PROGR1");
		cou.setCourseName("Programmeren I: Java");
		cou.setCourseWeight(6);		
		Course progrOne = cou;
		cou.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
		
		cou = new Course();
		cou.setCourseID("PROGR2");
		cou.setCourseName("Programmeren II: C en C++");
		cou.setCourseWeight(7);
		coll = new Vector();
		coll.add(progrOne);		
		cou.setPrerequisites(coll);
		Course progrTwo = cou;
		cou.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
		
		Student stu=new Student();
		stu.setStudentID("19991539");
		Address adres=new Address();
		adres.setCity("Waregem");
		adres.setNumber(9);
		adres.setStreet("Roterijstraat");
		adres.setZip("8790");
		stu.setAdres(adres);
		Name name=new Name();
		name.setFirstName("Bram");
		name.setLastName("Adams");
		stu.setName(name);
		Major maj = new Major();
		maj.setDepartment("Science Department");
		maj.setFaculty("Faculty of Applied Sciences");
		maj.setMajorID("Comp");
				maj.write();
				stu.setYearOfStudy(maj);
				Curriculum cur=new Curriculum();
				cur.setLow(10);
				cur.setHigh(20);
				coll=new ArrayList();
				coll.add(analysOne);
				coll.add(analysTwo);
				coll.add(analysThree);
				coll.add(progrOne);
				coll.add(progrTwo);
				cur.setCourses(coll);
				cur.write();
				stu.setProgramOfStudy(cur);
				stu.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
				id=stu.getOID();
				
		stu=new Student();
				stu.setStudentID("19971433");
				adres=new Address();
				adres.setCity("Durbuy");
				adres.setNumber(64);
				adres.setStreet("Rue de Comte Thodore");
				adres.setZip("6490");
				stu.setAdres(adres);
				name=new Name();
				name.setFirstName("Andr");
				name.setLastName("Hpital");
				stu.setName(name);
				maj = new Major();
		maj.setDepartment("Science Department");
		maj.setFaculty("Faculty of Sciences");
		maj.setMajorID("Math");

						maj.write();
						stu.setYearOfStudy(maj);
						cur=new Curriculum();
						cur.setLow(5);
						cur.setHigh(16);
						coll=new ArrayList();
						coll.add(analysOne);
						coll.add(analysTwo);
						cur.setCourses(coll);
						cur.write();
						stu.setProgramOfStudy(cur);
						stu.write();
		curr=new Date().getTime();
		collec.add(new Long(curr-prev));
		prev=new Date().getTime();
						
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		//Script.main(null);//drop and create tables
		super.tearDown();
	}

}
