package persistence.annotations;
/*
 * Created on 17-apr-2004
 *
 */

import java.lang.annotation.*;

/**
 * Annotation type for @persistent-attributes.
 * @author bram
 */
@Target({ElementType.FIELD}) @Documented @Retention(RetentionPolicy.CLASS)
public @interface PersistentAttribute {
	//ALGEMEEN
	public boolean accessor() default false;
	public boolean index() default false;
	public String get() default "";
	public String set() default "";
	
	//STRING
	public int size() default 256;

	//COLLECTION-/MAP-interface
	public String impClass() default "";
	
	//@persistent
	public String contained() default "false";
	
	//COLLECTION/MAP/ARRAY
	public MapContent[] content() default {};//bij primitieve niets!
}

