/*
 * Created on 17-apr-2004
 *
 */
package persistence.annotations;

import java.lang.annotation.*;

/**
 * Annotation type for @persistent-classes.
 * @author bram
 */
@Target({ElementType.TYPE}) @Documented @Retention(RetentionPolicy.CLASS)
public @interface PersistentClass {
	Database db() default @Database();
	Version version();//required!!
}
